#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.05.00 [26 May 2017]
#@  Commmand :
#@   -cpu=S3
#@   -obj_path=.\obj\
#@   -asm_path=.\obj\
#@   -dev=C:\Program Files (x86)\Renesas Electronics\Applilet EZ PL for RL78 V2.20\Tools\BIN\..\..\Tools\DEV\DR5F1058A.DVF
#@   -c
#@   -I C:\Program Files (x86)\Renesas Electronics\CS+\CC\CC-RL\V1.05.00\inc,.\include
#@   -Osize
#@   -pass_source
#@   src\timerpanel.c
#@  compiled at Fri Jun 15 13:40:40 2018

	.EXTERN _BitMemGet
	.EXTERN _BitMemSet
	.EXTERN _NOT1_
	.PUBLIC _TIMER_Initialize
	.EXTERN _memset
	.PUBLIC _TIMER_Counter_Clear
	.PUBLIC _TIMER_Processing

	.SECTION .textf,TEXTF
_TIMER_Initialize:
	.STACK _TIMER_Initialize = 4
	;***        1 : /*******************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only
	;***        4 : * intended for use with Renesas products. No other uses are authorized. This
	;***        5 : * software is owned by Renesas Electronics Corporation and is protected under
	;***        6 : * all applicable laws, including copyright laws.
	;***        7 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
	;***        8 : * THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
	;***        9 : * LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
	;***       10 : * AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
	;***       11 : * TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
	;***       12 : * ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
	;***       13 : * FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
	;***       14 : * ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
	;***       15 : * BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       16 : * Renesas reserves the right, without notice, to make changes to this software
	;***       17 : * and to discontinue the availability of this software. By using this software,
	;***       18 : * you agree to the additional terms and conditions found by accessing the
	;***       19 : * following link:
	;***       20 : * http://www.renesas.com/disclaimer
	;***       21 : *
	;***       22 : * Copyright (C) 2016 Renesas Electronics Corporation. All rights reserved.
	;***       23 : *******************************************************************************/
	;***       24 : 
	;***       25 : /*******************************************************************************
	;***       26 : * File Name    : timerpanel.c
	;***       27 : * Version      : Applilet EZ PL for RL78
	;***       28 : * Device(s)    : R5F1056A,R5F1057A,R5F1058A
	;***       29 : * Tool-Chain   : CC-RL
	;***       30 : * Description  : This file implements main function.
	;***       31 : * Creation Date: 2016/09/14
	;***       32 : *******************************************************************************/
	;***       33 : 
	;***       34 : /*******************************************************************************
	;***       35 : Includes <System Includes> , "Project Includes"
	;***       36 : *******************************************************************************/
	;***       37 : #include "sfr.h"
	;***       38 : #include "common.h"
	;***       39 : #include "config.h"
	;***       40 : #include <string.h>
	;***       41 : #include "timerpanel.h"
	;***       42 : 
	;***       43 : #if defined TIM_USED
	;***       44 : /*******************************************************************************
	;***       45 : Macro definitions
	;***       46 : *******************************************************************************/
	;***       47 : 
	;***       48 : /*******************************************************************************
	;***       49 : Typedef definitions
	;***       50 : *******************************************************************************/
	;***       51 : 
	;***       52 : /*******************************************************************************
	;***       53 : Imported global variables and functions (from other files)
	;***       54 : *******************************************************************************/
	;***       55 : 
	;***       56 : /*******************************************************************************
	;***       57 : Exported global variables and functions (to be accessed by other files)
	;***       58 : *******************************************************************************/
	;***       59 : 
	;***       60 : /*******************************************************************************
	;***       61 : Private variables and functions
	;***       62 : *******************************************************************************/
	;***       63 : static UCHAR	ucgTIMER_Last[(TIM_USED / 8) + 1];
	;***       64 : static UCHAR	ucgTIMER_LastIn[(TIM_USED / 8) + 1];
	;***       65 : static USHORT	usgTIMER_Val[TIM_USED];
	;***       66 : static UCHAR	ucgTIMER_Cnt = 0;
	;***       67 : 
	;***       68 : static UCHAR TIMER_Hold( UCHAR In, USHORT Cnt, UCHAR Trig);
	;***       69 : static UCHAR TIMER_Toggle( UCHAR In, USHORT Cnt, UCHAR Trig);
	;***       70 : static UCHAR TIMER_OneShotR( UCHAR In, USHORT Cnt, UCHAR Trig);
	;***       71 : static UCHAR TIMER_OneShotN( UCHAR In, USHORT Cnt, UCHAR Trig);
	;***       72 : 
	;***       73 : /*******************************************************************************
	;***       74 : * Function Name: TIMER_Hold
	;***       75 : * Description  : TIMER panel Hold-Type.
	;***       76 : * Arguments    : In   ... ON/OFF
	;***       77 : *                Cnt  ... time count
	;***       78 : *                Trig ... time unit (1sec or 50ms)
	;***       79 : * Return Value : out
	;***       80 : ********************************************************************************/
	;***       81 : UCHAR TIMER_Hold( UCHAR In, USHORT Cnt, UCHAR Trig )
	;***       82 : {
	;***       83 : 	UCHAR	ucret;
	;***       84 : 	USHORT	usval;
	;***       85 : 	
	;***       86 : 	if(In == LOW)
	;***       87 : 	{
	;***       88 : 		ucret = LOW;
	;***       89 : 		usval = 0;
	;***       90 : 	}
	;***       91 : 	else if(In == HIGH)
	;***       92 : 	{
	;***       93 : 		ucret = BitMemGet(ucgTIMER_Last, ucgTIMER_Cnt);
	;***       94 : 		usval = usgTIMER_Val[ucgTIMER_Cnt];
	;***       95 : 		if(Trig == HIGH)
	;***       96 : 		{
	;***       97 : 			usval ++;
	;***       98 : 			if(usval >= Cnt)
	;***       99 : 			{
	;***      100 : 				ucret = HIGH;
	;***      101 : 				usval = Cnt;
	;***      102 : 			}
	;***      103 : 		}
	;***      104 : 	}
	;***      105 : 	
	;***      106 : 	BitMemSet(ucgTIMER_Last, ucgTIMER_Cnt, ucret);
	;***      107 : 	usgTIMER_Val[ucgTIMER_Cnt] = usval;
	;***      108 : 	
	;***      109 : 	return (ucret);
	;***      110 : }
	;***      111 : 
	;***      112 : /*******************************************************************************
	;***      113 : * Function Name: TIMER_Toggle
	;***      114 : * Description  : TTIMER panel TOGGLE-Type.
	;***      115 : * Arguments    : In   ... ON/OFF
	;***      116 : *                Cnt  ... time count
	;***      117 : *                Trig ... time unit (1sec or 50ms)
	;***      118 : * Return Value : out
	;***      119 : ********************************************************************************/
	;***      120 : UCHAR TIMER_Toggle( UCHAR In, USHORT Cnt, UCHAR Trig )
	;***      121 : {
	;***      122 : 	UCHAR	ucret;
	;***      123 : 	USHORT	usval;
	;***      124 : 
	;***      125 : 	if(In == LOW)
	;***      126 : 	{
	;***      127 : 		ucret = LOW;
	;***      128 : 		usval = 0;
	;***      129 : 	}
	;***      130 : 	else if(In == HIGH)
	;***      131 : 	{
	;***      132 : 		ucret = BitMemGet(ucgTIMER_Last, ucgTIMER_Cnt);
	;***      133 : 		usval = usgTIMER_Val[ucgTIMER_Cnt];
	;***      134 : 		if(Trig == HIGH)
	;***      135 : 		{
	;***      136 : 			usval ++;
	;***      137 : 			if(usval >= Cnt)
	;***      138 : 			{
	;***      139 : 				ucret = NOT1_(ucret);
	;***      140 : 				usval = 0;
	;***      141 : 			}
	;***      142 : 		}
	;***      143 : 	}
	;***      144 : 
	;***      145 : 	BitMemSet(ucgTIMER_Last, ucgTIMER_Cnt, ucret);
	;***      146 : 	usgTIMER_Val[ucgTIMER_Cnt] = usval;
	;***      147 : 	
	;***      148 : 	return (ucret);
	;***      149 : }
	;***      150 : 
	;***      151 : /*******************************************************************************
	;***      152 : * Function Name: TIMER_OneShotR
	;***      153 : * Description  : TIMER panel OneShot(Retriggerable)-Type.
	;***      154 : * Arguments    : In   ... ON/OFF
	;***      155 : *                Cnt  ... time count
	;***      156 : *                Trig ... time unit (1sec or 50ms)
	;***      157 : * Return Value : out
	;***      158 : ********************************************************************************/
	;***      159 : UCHAR TIMER_OneShotR( UCHAR In, USHORT Cnt, UCHAR Trig )
	;***      160 : {
	;***      161 : 	UCHAR	ucret;
	;***      162 : 	UCHAR	uclastin;
	;***      163 : 	USHORT	usval;
	;***      164 : 	
	;***      165 : 	ucret = BitMemGet(ucgTIMER_Last, ucgTIMER_Cnt);
	;***      166 : 	uclastin = BitMemGet(ucgTIMER_LastIn, ucgTIMER_Cnt);
	;***      167 : 	usval = usgTIMER_Val[ucgTIMER_Cnt];
	;***      168 : 
	;***      169 : 	if(In == HIGH)
	;***      170 : 	{
	;***      171 : 		if(uclastin == LOW)
	;***      172 : 		{
	;***      173 : 			ucret = HIGH;
	;***      174 : 			usval = 0;
	;***      175 : 		}
	;***      176 : 	}
	;***      177 : 	
	;***      178 : 	if(ucret == HIGH)
	;***      179 : 	{
	;***      180 : 		if(Trig == HIGH)
	;***      181 : 		{
	;***      182 : 			usval ++;
	;***      183 : 			if(usval > Cnt)		ucret = LOW;
	;***      184 : 		}
	;***      185 : 	}
	;***      186 : 
	;***      187 : 	usgTIMER_Val[ucgTIMER_Cnt] = usval;
	;***      188 : 	BitMemSet(ucgTIMER_LastIn, ucgTIMER_Cnt, In);
	;***      189 : 	BitMemSet(ucgTIMER_Last, ucgTIMER_Cnt, ucret);
	;***      190 : 
	;***      191 : 	return (ucret);
	;***      192 : }
	;***      193 : 
	;***      194 : /*******************************************************************************
	;***      195 : * Function Name: TIMER_OneShotN
	;***      196 : * Description  : TIMER panel OneShot(Non-Triggerable)-Type.
	;***      197 : * Arguments    : In   ... ON/OFF
	;***      198 : *                Cnt  ... time count
	;***      199 : *                Trig ... time unit (1sec or 50ms)
	;***      200 : * Return Value : out
	;***      201 : ********************************************************************************/
	;***      202 : UCHAR TIMER_OneShotN( UCHAR In, USHORT Cnt, UCHAR Trig )
	;***      203 : {
	;***      204 : 	UCHAR	ucret;
	;***      205 : 	UCHAR	uclastin;
	;***      206 : 	USHORT	usval;
	;***      207 : 	
	;***      208 : 	ucret = BitMemGet(ucgTIMER_Last, ucgTIMER_Cnt);
	;***      209 : 	uclastin = BitMemGet(ucgTIMER_LastIn, ucgTIMER_Cnt);
	;***      210 : 	usval = usgTIMER_Val[ucgTIMER_Cnt];
	;***      211 : 
	;***      212 : 	if(In == HIGH)
	;***      213 : 	{
	;***      214 : 		if(uclastin == LOW)
	;***      215 : 		{
	;***      216 : 			if(ucret == LOW)
	;***      217 : 			{
	;***      218 : 				ucret = HIGH;
	;***      219 : 				usval = 0;
	;***      220 : 			}
	;***      221 : 		}
	;***      222 : 	}
	;***      223 : 	
	;***      224 : 	if(ucret == HIGH)
	;***      225 : 	{
	;***      226 : 		if(Trig == HIGH)
	;***      227 : 		{
	;***      228 : 			usval ++;
	;***      229 : 			if(usval > Cnt)		ucret = LOW;
	;***      230 : 		}
	;***      231 : 	}
	;***      232 : 
	;***      233 : 	usgTIMER_Val[ucgTIMER_Cnt] = usval;
	;***      234 : 	BitMemSet(ucgTIMER_LastIn, ucgTIMER_Cnt, In);
	;***      235 : 	BitMemSet(ucgTIMER_Last, ucgTIMER_Cnt, ucret);
	;***      236 : 
	;***      237 : 	return (ucret);
	;***      238 : }
	;***      239 : 
	;***      240 : /*******************************************************************************
	;***      241 : * Function Name: TIMER_Initialize
	;***      242 : * Description  : TIMER Panel Initialize.
	;***      243 : * Arguments    : none
	;***      244 : * Return Value : none
	;***      245 : ********************************************************************************/
	;***      246 : void TIMER_Initialize( void )
	;***      247 : {
	;***      248 : 	memset(ucgTIMER_Last, 0, (TIM_USED / 8) + 1);
	onew ax
	movw de, ax
	clrw bc
	movw ax, #LOWW(_ucgTIMER_Last@1)
	call !!_memset
	;***      249 : 	memset(ucgTIMER_LastIn, 0,(TIM_USED / 8) + 1);
	onew ax
	movw de, ax
	clrw bc
	movw ax, #LOWW(_ucgTIMER_LastIn@2)
	call !!_memset
	;***      250 : 	memset(usgTIMER_Val, 0, TIM_USED * 2);
	movw de, #0x0002
	clrw bc
	movw ax, #LOWW(_usgTIMER_Val@3)
	br !!_memset
_TIMER_Counter_Clear:
	.STACK _TIMER_Counter_Clear = 4
	;***      251 : }
	;***      252 : 
	;***      253 : /*******************************************************************************
	;***      254 : * Function Name: TIMER_Counter_Clear
	;***      255 : * Description  : TIMER Panel Counter Clear.
	;***      256 : * Arguments    : none
	;***      257 : * Return Value : none
	;***      258 : ********************************************************************************/
	;***      259 : void TIMER_Counter_Clear( void )
	;***      260 : {
	;***      261 : 	ucgTIMER_Cnt = 0;
	clrb !LOWW(_ucgTIMER_Cnt@4)
	ret
_TIMER_Processing:
	.STACK _TIMER_Processing = 12
	;***      262 : }
	;***      263 : 
	;***      264 : /*******************************************************************************
	;***      265 : * Function Name: TIMER_Processing
	;***      266 : * Description  : TIMER Panel Processing.
	;***      267 : * Arguments    : Mode      ... Timer Mode(TIMER_HOLD/TIMER_TOGGLE/TIMER_ONESHOT_R/TIMER_ONESHOT_N)
	;***      268 : *                ucTrg50ms ... 50ms Counter
	;***      269 : *                ucTrg1s   ... 1s Counter
	;***      270 : *                Sec       ... Second
	;***      271 : *                MSec      ... MiliSecound
	;***      272 : *                In        ... Input Value
	;***      273 : * Return Value : Out       ... Processing Value
	;***      274 : ********************************************************************************/
	;***      275 : UCHAR TIMER_Processing( UCHAR Mode, UCHAR ucTrg50ms, UCHAR ucTrg1s, USHORT Sec, USHORT MSec, UCHAR In )
	push de
	push bc
	push hl
	push ax
	mov h, a
	movw ax, [sp+0x06]
	;***      276 : {
	;***      277 : 	UCHAR	ucret;
	;***      278 : 	USHORT	uscnt;
	;***      279 : 	UCHAR	uctrig;
	;***      280 : 
	;***      281 : 	if(Sec < 1200)
	cmpw ax, #0x04B0
	movw ax, [sp+0x0C]
	movw de, ax
	bnc $.BB@LABEL@3_2
.BB@LABEL@3_1:	; if_then_bb
	movw ax, [sp+0x06]
	;***      282 : 	{
	;***      283 : 		uctrig = ucTrg50ms;
	;***      284 : 		uscnt = (20 * Sec) + (MSec / 50);
	movw bc, #0x0014
	mulh
	movw bc, ax
	movw ax, de
	movw de, #0x0032
	divhu
	addw ax, bc
	movw [sp+0x06], ax
	mov a, [sp+0x00]
	mov [sp+0x04], a
.BB@LABEL@3_2:	; if_break_bb
	;***      285 : 	}
	;***      286 : 	else
	;***      287 : 	{
	;***      288 : 		uctrig = ucTrg1s;
	;***      289 : 		uscnt = Sec;
	;***      290 : 	}
	;***      291 : 
	;***      292 : 	switch(Mode)
	dec h
	bz $.BB@LABEL@3_7
.BB@LABEL@3_3:	; if_break_bb
	dec h
	bz $.BB@LABEL@3_12
.BB@LABEL@3_4:	; if_break_bb
	dec h
	.bz $!.BB@LABEL@3_23
.BB@LABEL@3_5:	; if_break_bb
	dec h
	bz $.BB@LABEL@3_21
.BB@LABEL@3_6:	; if_break_bb.bb32_crit_edge
	mov [sp+0x00], a
	br $!.BB@LABEL@3_32
.BB@LABEL@3_7:	; bb
	mov a, [sp+0x05]
	cmp0 a
	bz $.BB@LABEL@3_13
.BB@LABEL@3_8:	; if_else_bb.i25
	dec a
	bnz $.BB@LABEL@3_15
.BB@LABEL@3_9:	; if_then_bb9.i33
	call $!__CommonCode@1
	bnz $.BB@LABEL@3_20
.BB@LABEL@3_10:	; if_then_bb21.i36
	movw ax, [sp+0x06]
	movw bc, ax
	movw ax, [sp+0x02]
	incw ax
	movw [sp+0x02], ax
	cmpw ax, bc
	bc $.BB@LABEL@3_20
.BB@LABEL@3_11:	; if_then_bb29.i37
	oneb a
	mov [sp+0x00], a
	movw ax, bc
	br $.BB@LABEL@3_19
.BB@LABEL@3_12:	; bb17
	mov a, [sp+0x05]
	cmp0 a
	bnz $.BB@LABEL@3_14
.BB@LABEL@3_13:	; bb17.TIMER_Toggle@1.exit_crit_edge
	clrw ax
	movw [sp+0x02], ax
	clrb a
	mov [sp+0x00], a
	br $.BB@LABEL@3_20
.BB@LABEL@3_14:	; if_else_bb.i
	dec a
	bz $.BB@LABEL@3_16
.BB@LABEL@3_15:	; if_else_bb.i.TIMER_Toggle@1.exit_crit_edge
	mov [sp+0x00], a
	br $.BB@LABEL@3_19
.BB@LABEL@3_16:	; if_then_bb9.i
	call $!__CommonCode@1
	bnz $.BB@LABEL@3_20
.BB@LABEL@3_17:	; if_then_bb21.i
	movw ax, [sp+0x06]
	movw bc, ax
	movw ax, [sp+0x02]
	incw ax
	movw [sp+0x02], ax
	cmpw ax, bc
	bc $.BB@LABEL@3_20
.BB@LABEL@3_18:	; if_then_bb29.i
	mov a, [sp+0x00]
	call !!_NOT1_
	mov [sp+0x00], a
	clrw ax
.BB@LABEL@3_19:	; if_then_bb29.i
	movw [sp+0x02], ax
.BB@LABEL@3_20:	; TIMER_Toggle@1.exit
	mov a, [sp+0x00]
	mov b, a
	mov c, !LOWW(_ucgTIMER_Cnt@4)
	movw ax, #LOWW(_ucgTIMER_Last@1)
	call !!_BitMemSet
	mov a, !LOWW(_ucgTIMER_Cnt@4)
	mov x, #0x02
	mulu x
	movw bc, ax
	movw ax, [sp+0x02]
	movw LOWW(_usgTIMER_Val@3)[bc], ax
	br $.BB@LABEL@3_32
.BB@LABEL@3_21:	; bb22
	call $!__CommonCode@0
	cmp0 b
	movw de, ax
	movw ax, [de]
	movw hl, ax
	bnz $.BB@LABEL@3_27
.BB@LABEL@3_22:	; bb22
	mov a, [sp+0x05]
	dec a
	bz $.BB@LABEL@3_26
	br $.BB@LABEL@3_27
.BB@LABEL@3_23:	; bb27
	call $!__CommonCode@0
	movw de, ax
	mov a, [sp+0x00]
	cmp0 a
	movw ax, [de]
	movw hl, ax
	bnz $.BB@LABEL@3_27
.BB@LABEL@3_24:	; bb27
	mov a, [sp+0x05]
	dec a
	bnz $.BB@LABEL@3_27
.BB@LABEL@3_25:	; bb27
	cmp0 b
	bnz $.BB@LABEL@3_27
.BB@LABEL@3_26:	; if_then_bb23.i
	clrw ax
	movw hl, ax
	oneb a
	mov [sp+0x00], a
.BB@LABEL@3_27:	; if_break_bb25.i
	mov a, [sp+0x00]
	dec a
	bnz $.BB@LABEL@3_31
.BB@LABEL@3_28:	; if_break_bb25.i
	mov a, [sp+0x04]
	dec a
	bnz $.BB@LABEL@3_31
.BB@LABEL@3_29:	; if_then_bb37.i
	movw ax, [sp+0x06]
	movw bc, ax
	movw ax, hl
	incw ax
	movw hl, ax
	cmpw ax, bc
	bnh $.BB@LABEL@3_31
.BB@LABEL@3_30:	; if_then_bb45.i
	clrb a
	mov [sp+0x00], a
.BB@LABEL@3_31:	; TIMER_OneShotN@1.exit
	movw ax, hl
	movw [de], ax
	mov a, [sp+0x05]
	mov b, a
	mov a, [sp+0x01]
	mov c, a
	movw ax, #LOWW(_ucgTIMER_LastIn@2)
	call !!_BitMemSet
	mov a, [sp+0x00]
	mov b, a
	mov c, !LOWW(_ucgTIMER_Cnt@4)
	movw ax, #LOWW(_ucgTIMER_Last@1)
	call !!_BitMemSet
.BB@LABEL@3_32:	; bb32
	;***      293 : 	{
	;***      294 : 		case TIMER_HOLD:
	;***      295 : 			ucret = TIMER_Hold(In, uscnt, uctrig);
	;***      296 : 			break;
	;***      297 : 		case TIMER_TOGGLE:
	;***      298 : 			ucret = TIMER_Toggle(In, uscnt, uctrig);
	;***      299 : 			break;
	;***      300 : 		case TIMER_ONESHOT_R:
	;***      301 : 			ucret = TIMER_OneShotR(In, uscnt, uctrig);
	;***      302 : 			break;
	;***      303 : 		case TIMER_ONESHOT_N:
	;***      304 : 			ucret = TIMER_OneShotN(In, uscnt, uctrig);
	;***      305 : 			break;
	;***      306 : 	}
	;***      307 : 
	;***      308 : 	ucgTIMER_Cnt ++;
	inc !LOWW(_ucgTIMER_Cnt@4)
	mov a, [sp+0x00]
	;***      309 : 
	;***      310 : 	return(ucret & 0x01);
	and a, #0x01
	;***      311 : }
	addw sp, #0x08
	ret
__CommonCode@0:
	.STACK __CommonCode@0 = 4
	mov c, !LOWW(_ucgTIMER_Cnt@4)
	movw ax, #LOWW(_ucgTIMER_Last@1)
	call !!_BitMemGet
	mov [sp+0x04], a
	mov c, !LOWW(_ucgTIMER_Cnt@4)
	movw ax, #LOWW(_ucgTIMER_LastIn@2)
	call !!_BitMemGet
	mov b, a
	mov a, !LOWW(_ucgTIMER_Cnt@4)
	mov [sp+0x05], a
	mov x, #0x02
	mulu x
	addw ax, #LOWW(_usgTIMER_Val@3)
	ret
__CommonCode@1:
	.STACK __CommonCode@1 = 4
	mov c, !LOWW(_ucgTIMER_Cnt@4)
	movw ax, #LOWW(_ucgTIMER_Last@1)
	call !!_BitMemGet
	mov [sp+0x04], a
	mov a, !LOWW(_ucgTIMER_Cnt@4)
	mov x, #0x02
	mulu x
	movw bc, ax
	movw ax, LOWW(_usgTIMER_Val@3)[bc]
	movw [sp+0x06], ax
	mov a, [sp+0x08]
	dec a
	ret
	;***      312 : #endif /* end of defined TIM_USED */
	;***      313 : 
	.SECTION .bss,BSS
_ucgTIMER_Last@1:
	.DS (1)
_ucgTIMER_LastIn@2:
	.DS (1)
	.ALIGN 2
_usgTIMER_Val@3:
	.DS (2)
	.SECTION .data,DATA
_ucgTIMER_Cnt@4:
	.DS (1)
